#include	<pic.h>

/*
 *	Demo program
 *
 *	Flashes LEDs on Port B, responds to switch press
 *	on RA1. Usable on PICDEM board.
 *
 *	Copyright (C)1997 HI-TECH Software.
 *	Freely distributable.
 */

#define BUTTON	RC1	//bit 1 of PORTC

main(void)
{
	unsigned char	i, j;

	TRISB = 0;		/* all bits output */
	j = 0;
	for(;;) {
		PORTB = 0x00;		/* turn all on */
		for(i = 100 ; --i ;)
			continue;
		PORTB = ~j;		/* output value of j */
		for(i = 100 ; --i ;)
			continue;
		if(BUTTON == 0)		/* if switch pressed, increment */
			j++;
	}
}
