;	Signed Byte division for PIC 16C5x

#ifdef	_PIC12
	psect	float_text1,class=ENTRY,delta=2,size=512
	psect	ftext,local,class=ENTRY,delta=2,with=float_text1
#else
	psect	float_text1,class=CODE,delta=2
#endif

	global	abdiv,abmod,dobdiv
	global	abdiv_t,abmod_t

;	Unsigned division - called with the dividend in w and the
;	divisor in btemp+1

#ifdef	_PIC12
#define	return	retlw 0
#endif

#include	"sfr.h"

abdiv
abmod
	SELTEMP	
	movwf	dend
abdiv_t
abmod_t
	SELTEMP
	clrf	flags
	btfss	dend,7		;check dividend sign bit
	goto	chkvis
	comf	dend
	incf	dend		;negate
	bsf	flags,6		;set remainder sign bit
	bsf	flags,7		;set quotient sign bit
chkvis
	movf	visor,w		;get divisor
	andlw	80h		;mask out sign bit
	xorwf	flags		;compute quotient sign
	btfss	visor,7		;check divisor sign bit
	goto	dobdiv
	comf	visor
	incf	visor		;negate
	goto	dobdiv


        psect   temp,global,class=BANK0,space=1,ovrld
dend	ds	1	;dividend
visor	ds	1	;divisor
quot	ds	1	;quotient
cntr	ds	1	;counter
flags	ds	1	;sign bits


	end
