;	Signed Word division for PIC 16C5x

	global	awdiv,awmod,dowdiv


#include	"sfr.h"


	psect	temp,global,class=BANK0,space=1
dend	ds	2	;dividend
visor	ds	2	;divisor
quot	ds	2	;quotient
cntr	ds	1	;counter
flags	equ	cntr	;sign bits

#ifdef	_PIC12
	psect	float_text1,class=ENTRY,delta=2,size=512
	psect	ftext0,class=ENTRY,delta=2,local,with=float_text1
#else
	psect	float_text1,class=CODE,delta=2
#endif
awdiv
awmod
	SELTEMP
	clrf	flags
	btfss	dend+1,7	;check dividend sign bit
	goto	chkvis
	comf	dend
	incf	dend
	btfsc	STATUS,Z
	decf	dend+1
	comf	dend+1
	bsf	flags,6		;set remainder sign bit
	bsf	flags,7		;set quotient sign bit
chkvis
	movf	visor+1,w	;get divisor
	andlw	80h		;mask out sign bit
	xorwf	flags		;compute quotient sign
	btfss	visor+1,7	;check divisor sign bit
	goto	dowdiv
	comf	visor
	incf	visor
	btfsc	STATUS,Z
	decf	visor+1
	comf	visor+1
	goto	dowdiv		;go do division

	end
