#ifdef	_PIC14
;	Routine to fetch calibration data from
;	the calibration area in a PIC14000, and convert
;	it to IEEE 754 double (little endian) or 24 bit
;	truncated IEEE754.

;	NOTE!! Must be compiled with "preprocess assembler files" on
;	or use a -P option to picc

	global	?_get_cal_data
	global	?a_main
	global	_get_cal_data
	FNSIZE	_get_cal_data,0,2
	global	code_ptr
	global	string_table
	global	string_indir
	global	used_btemp0
	global	used_btemp1
	global	used_btemp2
	FNCALL	_get_cal_data,string_indir

#if	sizeof(double) == 4
#define	dsize	4
	signat	_get_cal_data,4212
	global	used_btemp3
#else
	signat	_get_cal_data,4211
#define	dsize	3
#endif

	psect	text0,local,class=CODE,delta=2
	psect	temp,global,ovrld,class=BANK0,space=1

	psect	text0
_get_cal_data
;	_val assigned to ?a_get_cal_data+0
	bcf	3,5
	movf	(?_get_cal_data+1)&127,w
	movwf	code_ptr+1
	movf	?_get_cal_data&127,w		;get pointer low byte
	fcall	string_table			;get MS byte
	movwf	btemp+dsize-1
	fcall	string_indir			;get middle byte
	movwf	btemp+dsize-2
	fcall	string_indir			;get LS (or middle) byte
	movwf	btemp+dsize-3
#if	sizeof(double) == 4
	fcall	string_indir			;get LS byte for doubles
	movwf	btemp+dsize-4
#endif
;f14000.c: 15: val.xval[2] = (val.xval[2] & 0x7F) | (val.xval[3] << 7);

	rlf	btemp+dsize-2			;Shift sign bit out
	rrf	btemp+dsize-1			;Shift into exponent byte
	rrf	btemp+dsize-2			;Shift exponent LS bit into next byte
	
	return

	psect	temp
btemp
	ds	dsize
#endif	/* _PIC14 */
	end
