;	Copyright (C) 1997 HI-TECH Software 

;	Single Precision IEEE Floating point arithmetic routines for PIC
;	Assignment Addition done here


#include	"double.h"

	global	fladd_x
	global	fladd_f,flsub_f
	global	fldenorm,flunpack1,flunpack2
	FNCALL	fladd_f,flunpack1
	FNCALL	fladd_f,flunpack2
	FNCALL	fladd_f,fldenorm
	FNCALL	flsub_f,flunpack1
	FNCALL	flsub_f,flunpack2
	FNCALL	flsub_f,fldenorm

;	subtract two numbers

flsub_f
#ifdef	_PIC16
	movfp	BSR,TBLPTRL
#endif
	movlw	80h
	SELTEMP
	xorwf	mant2+3		;toggle sign of the RHS
#ifdef	_PIC16
	movfp	TBLPTRL,BSR	;restore bank number for indirect code below
#endif

;	fall through

;	Add the number pointed to by fsr  to the number in op2 and return the result in ctemp

fladd_f
#ifdef	_PIC16
	movfp	BSR,TBLPTRL
#else
	SELTEMP
#endif
	movf	INDF,w
	movwf	mant1+0
	incf	FSR
	movf	INDF,w
	movwf	mant1+1
	incf	FSR
	movf	INDF,w
	movwf	mant1+2
	incf	FSR
	movf	INDF,w
	movwf	mant1+3
	; fladd_x calls flunpack1 which selects the temp-resident bank
	goto	fladd_x

	end
