
;	Copyright (C) 1997 HI-TECH Software 

;	Single Precision IEEE Floating point arithmetic routines for PIC
;	Multiplication done here


#include	"double.h"

	global	flmul,flmul_x

;
;	Multiply the float in ctemp by the float on the stack and return
;	the result in ctemp

	global	flunpack1,flunpack2
	FNCALL	flmul,flunpack1
	FNCALL	flmul,flunpack2
	FNCALL	flmul_x,flunpack1
	FNCALL	flmul_x,flunpack2

flmul
	clrf	FSR
flmul_x
	call	flunpack1
	call	flunpack2
	clrf	prod
	clrf	prod+1
	clrf	prod+2
	clrf	prod+3
	movlw	7		;initialize counter
	movwf	cntr
mup1
	bcf	STATUS,C
	rrf	mant2+2		;shift multiplier down one bit
	rrf	mant2+1
	rrf	mant2+0
	btfss	STATUS,C	;if bit 0 was set
	goto	nobit
	movf	mant1,w		;add multiplicand to product
	addwf	prod
	movf	mant1+1,w
	btfsc	STATUS,C
	incfsz	mant1+1,w
	addwf	prod+1
	movf	mant1+2,w
	btfsc	STATUS,C
	incfsz	mant1+2,w
	addwf	prod+2
	movf	mant1+3,w
	btfsc	STATUS,C
	incf	mant1+3,w
	addwf	prod+3
nobit
	bcf	STATUS,C
	rlf	mant1+0		;shift multiplicand up one bit
	rlf	mant1+1
	rlf	mant1+2
	rlf	mant1+3
	decfsz	cntr		;decrement counter
	goto	mup1		;loop if more

	movlw	17		;re initialize counter
	movwf	cntr
	goto	mup3
mup11
	bcf	STATUS,C
	rrf	prod+3		;shift product down one bit
	rrf	prod+2
	rrf	prod+1
	rrf	prod+0
mup3
	bcf	STATUS,C
	rrf	mant2+2		;shift multiplier down one bit+2
	rrf	mant2+1
	rrf	mant2+0
	btfss	STATUS,C	;was it set
	goto	mup2		;nope, don't add
	movf	mant1,w		;add multiplicand to product
	addwf	prod
	movf	mant1+1,w
	btfsc	STATUS,C
	incfsz	mant1+1,w
	addwf	prod+1
	movf	mant1+2,w
	btfsc	STATUS,C
	incfsz	mant1+2,w
	addwf	prod+2
	movf	mant1+3,w
	btfsc	STATUS,C
	incf	mant1+3,w
	addwf	prod+3
mup2
	decfsz	cntr		;loop if more
	goto	mup11

	rrf	signs,w		;get sign of RHS in bit 0
	xorwf	signs		;xor with LHS sign
;1:
	movf	prod+0,w		;copy product to mant1
	movwf	mant1+0
	movf	prod+1,w
	movwf	mant1+1
	movf	prod+2,w
	movwf	mant1+2
	movf	prod+3,w
	movwf	mant1+3

	movlw	-(127+7)	;get exponent adjustment
	addwf	exp2,w		;add RHS exponent
	addwf	exp1		;add LHS exponent

	goto	flnorm1		;normalize

	end
