;	Copyright (C) 1997 HI-TECH Software 

;	Single Precision IEEE Floating point arithmetic routines for PIC
;	Assignment Addition done here


#include	"float.h"

	global	ftadd_x
	global	ftadd_f,ftsub_f
	global	ftdenorm,ftunpack1,ftunpack2
	FNCALL	ftadd_f,ftunpack1
	FNCALL	ftadd_f,ftunpack2
	FNCALL	ftadd_f,ftdenorm
	FNCALL	ftsub_f,ftunpack1
	FNCALL	ftsub_f,ftunpack2
	FNCALL	ftsub_f,ftdenorm

;	subtract two numbers

#ifdef	_PIC12
	psect	ftext0,local,class=ENTRY,delta=2,with=float_text4
#endif
ftsub_f
#ifdef	_PIC16
	movfp	BSR,TBLPTRL
#endif
	movlw	80h
	SELTEMP			;mant2 may be in bank0
	xorwf	mant2+2		;toggle sign of the RHS
#ifdef _PIC16
	movfp	TBLPTRL,BSR
#endif
#ifdef	_PIC12
	goto	ftadd_f
#endif

;	fall through

;	Add the number pointed to by fsr to the number in op2 and return the result in ctemp

#ifdef	_PIC12
	psect	ftext1,local,class=ENTRY,delta=2,with=float_text4
#endif
ftadd_f
#ifdef	_PIC16
	movfp	BSR,TBLPTRL
#else
	SELTEMP
#endif
	movf	INDF,w
	movwf	mant1+0
	incf	FSR
	movf	INDF,w
	movwf	mant1+1
	incf	FSR
	movf	INDF,w
	movwf	mant1+2
	; ftadd_x calls ftunpack1 which ensures the temp-resident bank is selected
	goto	ftadd_x

	end
