;	Copyright (C) 1997 HI-TECH Software 

;	Single Precision IEEE Floating point arithmetic routines for PIC
;	Division done here


#include	"float.h"

	global	ftdiv,ftdiv_x

	global	used_btemp9
	global	used_btemp10
	global	used_btemp11

	global	ftunpack1,ftunpack2
	FNCALL	ftdiv,ftunpack1
	FNCALL	ftdiv,ftunpack2
	FNCALL	ftdiv_x,ftunpack1
	FNCALL	ftdiv_x,ftunpack2

;	Floating divide: divide the number in mant1 by mant2

#ifdef	_PIC12
	psect	ftext0,local,class=ENTRY,delta=2,with=float_text4
#endif
ftdiv
	clrf	FSR
ftdiv_x
	call	ftunpack1
	call	ftunpack2

divide
	clrf	prod
	clrf	prod+1
	clrf	prod+2
#ifdef	_PIC16
	movf	exp1,w		;check for zero dividend
	iorlw	0
#else
	movf	exp1		;check for zero dividend
#endif
	btfsc	STATUS,Z	;if zero, we are finished
	return
	movf	exp2,w		;check for zero divisor
#ifdef	_PIC16
	iorlw	0
#endif
	btfsc	STATUS,Z
	return

	subwf	exp1,w		;compute new exponent
#ifdef	_PIC12
	movwf	exp1
	movlw	127-8
	addwf	exp1
#else
	addlw	127-8		;unbias
	movwf	exp1		;store back
#endif
	rrf	signs,w		;get sign of RHS in bit 0
	xorwf	signs		;xor with LHS sign

	movlw	16+8		;initialize counter
	movwf	cntr
div1
	bcf	STATUS,C
	rlf	prod+0		;shift quotient up
	rlf	prod+1
	rlf	prod+2
#ifdef	_PIC16
	tstfsz	mant1+2		;check msb of dividend
#else
	movf	mant1+2,w	;check msb of dividend
	btfss	STATUS,Z	;skip if zero
#endif
	goto	div4
	movf	mant2+1,w
	subwf	mant1+1,w	;check for subtract
	btfss	STATUS,Z	;if equal, check next byte
	goto	div3
	movf	mant2+0,w
	subwf	mant1+0,w	;check for subtract
div3
	btfss	STATUS,C	;carry is borrow complemented
	goto	div2		;sip the subtract
div4
        movf    mant2+0,w	;subtract mantissas
	subwf   mant1+0
	movf    mant2+1,w
#ifdef	_PIC16
	subwfb	mant1+1
#else
	btfss   STATUS,0
	incfsz  mant2+1,w
	subwf   mant1+1
#endif
	btfss	STATUS,C
	decf	mant1+2
	bsf	prod,0
div2
	bcf	STATUS,C
	rlf	mant1+0
	rlf	mant1+1
	rlf	mant1+2
	decfsz	cntr
	goto	div1
	movf	prod,w
	movwf	mant1
	movf	prod+1,w
	movwf	mant1+1
	movf	prod+2,w
	movwf	mant1+2
	goto	ftnorm1		;now normalize result

        psect   temp,ovrld,class=BANK0,space=1
prod	ds	3
	end
