#define _USEBANKBITS
#include	"sfr.h"

	psect	strings,class=STRING,delta=2
	psect	stringtable,class=ENTRY,delta=2

#ifdef	_PIC14
	global	string_table,string_indir,used_code_ptr,code_ptr
used_code_ptr	equ	1

;This code is called with a 16 bit index in code_ptr
;The high bit of the second byte is set if the address refers to RAM

string_table				;on entry here, the low byte is in W
	SELBANK0
	movwf	code_ptr
string_indir
	btfsc	code_ptr+1,7		;hi bit set if a RAM pointer
	goto	getram			;go read RAM
#ifdef	_PROGMEM_
	btfsc	code_ptr+1,6
	goto	read_progmem		;go read program memory
#endif
	movf	code_ptr+1,w		;get hi byte of pointer
	movwf	PCLATH
	movf	code_ptr,w		;get low byte
	incf	code_ptr		;increment it
	btfsc	STATUS,Z		;overflow?
	incf	code_ptr+1		;increment high byte
	movwf	PCL			;do the jump

getram
	bcf	STATUS,7		;clear IRP
	btfsc	code_ptr+1,0		;test hi bit of 9 bit pointer
	bsf	STATUS,7
	movf	code_ptr,w		;get pointer
	incf	code_ptr		;increment it
	movwf	FSR
	movf	0,w			;read it
	return
read_progmem
	; code to read program memory gets linked here if required

	psect	code_ptr,global,class=BANK0,space=1,ovrld
	ds	2
#endif
#ifdef	_PIC12
used_code_ptr	equ	1
	global	stringbase
;	This code is called with an 8 bit pointer in W.
;	It unconditionally refers to ROM
	global	string_direct

string_direct
	movwf	PCL
stringbase
#endif

#ifdef	_PIC16
        psect   cstrings,global,class=CODE,delta=1
	global	stringbase
stringbase
#endif
	end
