;	Structure copy for PIC

#ifdef	_PIC12
	psect	float_text1,class=ENTRY,delta=2
	psect	ftext0,class=ENTRY,local,delta=2,with=float_text1
#else
	psect	float_text1,class=CODE,delta=2
#endif

;	Called with source pointer in FSR, destination pointer
;	in btemp. For highend processors, count is in btemp+1;
;	other devices place count in w

	global	structcopy

#include	"sfr.h"

structcopy
#ifndef	_PIC16
	movwf	count
#endif
lop
	movf	0,w		;get source byte
	movwf	byte		;save it
	incf	FSR,w		;increment pointer
	movwf	source		;save
	movf	dest,w
	movwf	FSR
#ifdef _PIC16
	movpf	BSR,dest
	movfp	TBLPTRL,BSR
#endif	
	movf	byte,w		;copy byte
	movwf	0
#ifdef _PIC16
	movfp	dest,BSR
#endif
	incf	FSR,w
	movwf	dest		;store dest pointer
	movf	source,w
	movwf	FSR		;source pointer again
lop1
	decfsz	count		;decrement count
	goto	lop		;loop if more
	retlw	0

        psect   temp,global,class=BANK0,space=1,ovrld
dest	ds	1
count	ds	1
source	ds	1
byte	ds	1

	global	used_btemp0
	global	used_btemp1
	global	used_btemp2
	global	used_btemp3

	end
