#include	"sfr.h"
#ifdef	_PIC14
;	Structure copy for PICs

	psect	float_text1,class=CODE,delta=2

;	Called with destination pointer in FSR, source pointer
;	in btemp (16 bits). For highend processors, the count
;	is placed in btemp+2; other devices place this in w

	global	codecopy,string_indir,structcopy,code_ptr
	FNCALL	codecopy,string_indir

codecopy
#ifndef	_PIC16
	movwf	count
#endif
	movf	code_ptr+1,w	;test high byte of source
	andlw	80h
	btfsc	STATUS,Z	;skip if not zero
	goto	lop		;go do ROM-to-RAM copy
	movf	FSR,w		;exchange source and destination
        xorwf   code_ptr,w
        xorwf   code_ptr,f
        xorwf   code_ptr,w
	movwf	FSR
	goto	structcopy	;go do a RAM to RAM copy
	
lop
	fcall	string_indir
	movwf	0		;save it
	incf	FSR
lop1
	decfsz	count		;decrement count
	goto	lop		;loop if more
	retlw	0

        psect   temp,global,class=BANK0,space=1,ovrld
count	ds	1

	global	used_btemp0

#endif

#ifdef	_PIC12
;	Structure copy for PIC12

	psect	float_text1,class=ENTRY,delta=2,size=512

;	CAlled with destination pointer in FSR, source pointer
;	in btemp (16 bits), count in w

	global	codecopy,string_indir,code_ptr


	psect	ftext0,class=ENTRY,local,delta=2,with=float_text1
codecopy
	movwf	count
lop
	fcall	string_indir
	movwf	0		;save it
	incf	FSR
lop1
	decfsz	count		;decrement count
	goto	lop		;loop if more
	retlw	0

        psect   temp,global,class=BANK0,space=1,ovrld
count	ds	1
#endif
	end
