;	Copyright (C) 1997 HI-TECH Software 

#include	"double.h"

;	Compare two doubles and set flags accordingly

	global	flcmp

flcmp
	SELTEMP
	movf	mant1+3,w	;check signs first
	xorwf	mant2+3,w
	andlw	80h		;mask out sign bit
	btfsc	STATUS,Z
	goto	cexp		;same, compare exponents and mantissas
	rlf	mant2+3,w	;put msb into carry
	movf	mant2+3,w
	iorlw	1		;reset z flag
	return
cexp
	bcf	mant1+3,7	;reset sign bit on RHS
	movf	mant2+3,w		
	andlw	7Fh
	subwf	mant1+3,w	;subtract
	btfss	STATUS,Z	;skip if equal
	goto	diff
	movf	mant2+2,w
	subwf	mant1+2,w
	btfss	STATUS,Z	;skip if equal
	goto	diff
	movf	mant2+1,w
	subwf	mant1+1,w
	btfss	STATUS,Z	;skip if equal
	goto	diff
	movf	mant2+0,w
	subwf	mant1+0,w
	btfsc	STATUS,Z	;skip if not equal
	return			;return with zero set
diff
	rlf	mant2+3,w	;get carry bit into W bit 0 
	btfsc	STATUS,C	;Check sign bit - if set toggle result
	xorlw	1		;toggle carry
	movwf	mant2+3		;store to memory
	rrf	mant2+3,w	;rotate bit back into carry
	iorlw	2		;reset Z flag
	return
