;	Copyright (C) 1997 HI-TECH Software 

#include	"float.h"

;	Compare two doubles and set flags accordingly

	global	ftcmp

#ifdef	_PIC12
	psect	ftext0,local,class=ENTRY,delta=2,with=float_text4
#endif
ftcmp
	SELTEMP
	movf	mant1+2,w	;check signs first
	xorwf	mant2+2,w
	andlw	80h		;mask out sign bit
	btfsc	STATUS,Z
	goto	cexp		;same, compare exponents and mantissas
	rlf	mant2+2,w	;put msb into carry
	movf	mant2+2,w
	iorlw	1		;reset z flag
	return
cexp
	bcf	mant1+2,7	;reset sign bit on RHS
	movf	mant2+2,w		
	andlw	7Fh
	subwf	mant1+2,w	;subtract
	btfss	STATUS,Z	;skip if equal
	goto	diff
	movf	mant2+1,w
	subwf	mant1+1,w
	btfss	STATUS,Z	;skip if equal
	goto	diff
	movf	mant2+0,w
	subwf	mant1+0,w
	btfsc	STATUS,Z	;skip if not equal
	return			;return with zero set
diff
	movf	STATUS,w	;get status
	iorlw	2		;make non-zero
	btfsc	mant2+2,7	;if sign bit clear, do nothing
	xorlw	1		;toggle carry
	movwf	STATUS
	btfsc	STATUS,C	;if carry set
	iorlw	80h		;set sign bit
	return
