;	Structure copy for PIC
; 	Is used for copying structures where source & destination banks differ.
;	Not used by highend processors

#ifdef	_PIC12
	psect	float_text1,class=ENTRY,delta=2
	psect	ftext0,class=ENTRY,local,delta=2,with=float_text1
#else
	psect	float_text1,class=CODE,delta=2
#endif

;	Called with source pointer in FSR, destination pointer
;	in btemp, count in w.

	global	structbank

#include	"sfr.h"

#if (_COMMON_)
#define BBIT0	5
#define BBIT1	6
#else
#define BBIT0	0
#define BBIT1	1
#endif


structbank
#if (!_COMMON_)
	bcf	STATUS,1
#if	_BANKBITS_ == 2
	btfsc	STATUS,6
	bsf	STATUS,1
#endif
	SELTEMP	
#endif

	movwf	count
lop
	movf	0,w		;get source byte
	movwf	byte		;save it
	incf	FSR,w		;increment pointer
	movwf	source		;save
	movf	dest,w
	movwf	FSR
	bcf	STATUS,BBIT0	; save IRP bit
	btfsc	STATUS,7
	bsf	STATUS,BBIT0
	bcf	STATUS,7
	btfsc	STATUS,BBIT1	; set dest IRP bit
	bsf	STATUS,7
	movf	byte,w		;copy byte
	movwf	0
	incf	FSR,w
	movwf	dest		;store dest pointer
	movf	source,w
	movwf	FSR		;source pointer again
	bcf	STATUS,BBIT1	;save IRP bit
	btfsc	STATUS,7
	bsf	STATUS,BBIT1
	bcf	STATUS,7
	btfsc	STATUS,BBIT0	;set source IRP bit
	bsf	STATUS,7
lop1
	decfsz	count		;decrement count
	goto	lop		;loop if more
	retlw	0

        psect   temp,global,class=BANK0,space=1,ovrld
dest	ds	1
count	ds	1
source	ds	1
byte	ds	1

	global	used_btemp0
	global	used_btemp1
	global	used_btemp2
	global	used_btemp3

	end
